/*
 * CMSC 12300 - Computer Science with Applications 3
 * Borja Sotomayor, 2013 (original code)
 * Matthew Wachs, 2016 (quick and dirty port to C)
 *
 * An implementation of the thread pool pattern.
 *
 * See ThreadPool.h for details.
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include "ThreadPool.h"
#include "WorkerThread.h"

// Use the next three functions to manipulate the queue of tasks maintained in the pool
// These use an array to represent a queue,
// with all the items at the beginning of the array.
// This is not a good way to implement a queue.
// One should use a linked list.
// That way, you do not need to copy elements down the array.
// But, we haven't had a lot of practice with linked lists yet.

unsigned int queue_length(ThreadPool* t) {
    unsigned int i;
    for (i = 0; i < MAX_TASKS; i++) {
        if (t->q[i] == NULL) {
            return i;
        }
    }
    return i;
}

USAGovClickTask* queue_dequeue(ThreadPool* t) {
    USAGovClickTask* rv = t->q[0];
    if (rv == NULL) {
        fprintf(stderr, "pop from empty queue\n");
        exit(1);
    }
    
    unsigned int i;
    for (i = 0; i < MAX_TASKS; i++) {
        t->q[i] = t->q[i+1];
    }
    t->q[MAX_TASKS-1] = NULL;
    
    return rv;
}

void queue_enqueue(ThreadPool* t, USAGovClickTask* task) {
    unsigned int i;
    for (i = 0; i < MAX_TASKS; i++) {
        if (t->q[i] == NULL) {
            t->q[i] = task;
            return;
        }
    }
    
    fprintf(stderr, "attempt to push to full queue\n");
    exit(1);
}

ThreadPool* pool_init(int numWorkers) {
    if (numWorkers > MAX_THREADS) {
        fprintf(stderr, "Number of threads can be at most %d, but you specified -t %d\n", MAX_THREADS, numWorkers);
        exit(1);
    }
    
    int i;
    ThreadPool* t = (ThreadPool*)malloc(sizeof(ThreadPool));
    t->numWorkers = numWorkers;
    pthread_mutex_init(&t->m, NULL);
    pthread_cond_init(&t->cvQueueNonEmpty, NULL);
    
    for (i = 0; i < MAX_THREADS; i++) {
        t->workers[i] = NULL;
    }
    
    for (i = 0; i < MAX_TASKS; i++) {
        t->q[i] = NULL;
    }
    
    /* YOUR CODE GOES HERE */
    
    return t;
}

void pool_free(ThreadPool* t) {
    free(t);
}

bool pool_schedule(ThreadPool* t, USAGovClickTask *task) {
	/* YOUR CODE GOES HERE */
    return false; /* placeholder, replace this: don't always return false */
}

void pool_stop(ThreadPool* t) {
	/* YOUR CODE GOES HERE */
}
